/****************************************************************************
** StructureToolBar - class
**
** Created: Tue May 08 12:09:08 2004
**      by: Varol Okan using kate editor
**
** This class will create a toolbar, which holds only one widget.
** The StructureWidget is displaying the current structure of the DVD.
**
****************************************************************************/
#include <qmainwindow.h>
#include <qmessagebox.h>

#include "global.h"
#include "colortoolbar.h"

QColorFrame::QColorFrame (int iWhichColor, QColor theColor, QWidget *pParent, const char *pName, WFlags f)
	: QFrame (pParent, pName, f)
{
	m_iWhichColor = iWhichColor;
	setPaletteBackgroundColor (theColor);
    setFixedSize( QSize( 30, 30 ) );
    setFrameShape( QFrame::GroupBoxPanel );
    setFrameShadow( QFrame::Raised );
    setLineWidth( 3 );
}

void QColorFrame::mouseReleaseEvent (QMouseEvent *pMouseEvent)
{
	QFrame::mouseReleaseEvent(pMouseEvent);
//	if (pMouseEvent->button() == RightButton)
	emit (signalRightButtonClicked (m_iWhichColor));
}

QColor QColorFrame::getColor()
{
	return paletteBackgroundColor();
}


ColorToolBar::ColorToolBar (const QString &qsLabel, QMainWindow *pMainWindow, QWidget *pParent, bool bNewLine, const char *pName, WFlags f)
	: QToolBar (qsLabel, pMainWindow, pParent, bNewLine, pName, f)
{
	setResizeEnabled (false);
	setMovingEnabled (true);
	pMainWindow->addDockWindow (this, Top);

	// Next we include the 4 colors for the Button masks into the main toolbar.
	m_colorFrames[0] = new QColorFrame (0, QColor (TRANSPARENT_COLOR), this);
	m_colorFrames[1] = new QColorFrame (1, QColor (START_HIGHLIGHTED_COLOR), this);
	m_colorFrames[2] = new QColorFrame (2, QColor (START_SELECTED_COLOR), this);
	m_colorFrames[3] = new QColorFrame (3, QColor (START_FRAME_COLOR), this);

	connect (m_colorFrames[0], SIGNAL(signalRightButtonClicked (int)), this, SLOT(slotColorClicked(int)));
	connect (m_colorFrames[1], SIGNAL(signalRightButtonClicked (int)), this, SLOT(slotColorClicked(int)));
	connect (m_colorFrames[2], SIGNAL(signalRightButtonClicked (int)), this, SLOT(slotColorClicked(int)));
	connect (m_colorFrames[3], SIGNAL(signalRightButtonClicked (int)), this, SLOT(slotColorClicked(int)));
}

ColorToolBar::~ColorToolBar ()
{

}

void ColorToolBar::slotColorClicked(int)
{
	QMessageBox::warning (this, "Not implemented yet", "This function is not yet implemented",
		QMessageBox::Ok, QMessageBox::NoButton);
}

QColor ColorToolBar::getColor(int iWhichColor)
{
	return m_colorFrames[iWhichColor]->getColor();
}


