#ifndef GLOBAL_H
#define GLOBAL_H

#define DEBUG_INFO 1


#define STRING_SEPARATOR "+-+"
// here we define the file name of the ini file.
#define INI_FILE_NAME "~/.qdvdauthorrc"

// The initial project file name for a new project. Need to get changed manually
#define PROJECT_FILENAME "Unnamed.xml"
#define PROJECT_NAME     "Unnamed"

// This variable tells us where the bash shell is located. Needed for the generated scripts
#define BASH_STRING "#!/bin/bash\n\n" 

// Here are the defines for the different video modes
#define FORMAT_NONE		0
#define FORMAT_NTSC1	1
#define FORMAT_NTSC2	2
#define FORMAT_NTSC3	3
#define FORMAT_NTSC4	4
#define FORMAT_PAL1		5
#define FORMAT_PAL2		6
#define FORMAT_PAL3		7
#define FORMAT_PAL4		8


#define BACKGROUND_IMG		0
#define SELECTED_MASK		1
#define HIGHLIGHTED_MASK	2

#define BACKGROUND_NAME		"background.jpg"
#define SELECTED_NAME		"selected.png"
#define HIGHLIGHTED_NAME	"highlighted.png"

// The max colors a mask (button) can have. Either 4 or 16, not sure.
#define MAX_MASK_COLORS 4

// Here we define the color which is to be interpreted as transparent (only used as a type of flag)
#define TRANSPARENT_COLOR        254, 255, 254

// These are the standard colors for the SELECTED, and HIGHLIGHTED layer.
// Note: max of 4 colors are allowed, so colorspace is sparse.
#define START_HIGHLIGHTED_COLOR  250,150,50
#define START_SELECTED_COLOR     255, 20, 20

// This color is applied to the background, thus it can be different unless the user 
// decides to put it onto a Selected / highlighted layer.
#define START_FRAME_COLOR        255, 255, 20

// These defines specify the color to use in the SourceFileToolbar
//#define COLOR_MOVIE_FILES 110, 160, 210
#define COLOR_MOVIE_FILES_OK  140, 200, 250
#define COLOR_MOVIE_FILES_BAD 140,  20,  50
#define COLOR_SOUND_FILES_OK   80,  80, 220
#define COLOR_SOUND_FILES_BAD  16,  16,  44
#define COLOR_SLIDE_FILES_OK  210, 130, 170
#define COLOR_SLIDE_FILES_BAD  42,  26,  34

// PI is always good to have
#ifndef PI
#define PI 3.14
#endif

// if the Magic++ library is installed then use ImageMagick's functionality.
#define USE_IMAGE_MAGICK_LIB 1

// The following define is set if the program should rather use
// the command line tools provided with ImageMagick, such as
// convert, montage, mogrify etc.
// See qimagehelper.cpp for further details ...
//#define USE_IMAGE_MAGICK_CMDLINE 1

// If the user has CxImage or prefers it ...
//#define USE_CXIMAGE

// FreeImage is promising smal and comprehensive.
//#define USE_FREEIMAGE

// Well ...
//#define USE_IMGLIB

#endif // GLOBAL_H
