unix {
  UI_DIR = .ui
  MOC_DIR = .moc
  OBJECTS_DIR = .obj
}

# Now we parse the env varaible IMAGE_LIB (set in the configurator GUI)
WHICH_IMAGE_LIB = $$(IMAGE_LIB)
WHICH_QT_LIB = $$(QT_LIB)
WHICH_PREFIX = $$(PREFIX)

isEmpty(WHICH_IMAGE_LIB) {
	exists (../bin/confiugrator)	{
		system (../bin/configurator &)
	} else {
		system (cd ..; configure &)
	}
	error ( "Please use configurator or set all neccesary environment variables before calling qmake" )
}

contains( WHICH_IMAGE_LIB, imagemagicklib) {
	LIBS += `Magick++-config --cxxflags --cppflags --ldflags --libs;`
}
imagemagickcmdline {

}
contains( WHICH_IMAGE_LIB, cximage) {
	LIBS += -lcximage
}
contains( WHICH_IMAGE_LIB, imgsource) {
	LIBS += -limglib
}
contains( WHICH_IMAGE_LIB, devil) {
	LIBS += -lopenil
}
contains( WHICH_IMAGE_LIB, paintlib) {
        LIBS += -lpaintlib
}
contains( WHICH_IMAGE_LIB, freeimage) {
	# I kept the FreeImagePlus sources because of the non-standard Makefile.
	# thus, we shold first compile the library under ROOT/addons/FreeImagePlus
	system (cd ../addons/FreeImagePlus; make)
	LIBS += -L../addons/FreeImagePlus -lfreeimageplus
}

LIBS +=`xine-config --cflags --libs`

SOURCES	+= main.cpp\
	execute.cpp \
	dvdinfo.cpp  \
	dvdmenu.cpp   \
	dialogman.cpp  \
	qdvdauthor.cpp  \
	menuobject.cpp   \
	textobject.cpp    \
	frameobject.cpp    \
	imageobject.cpp     \
	movieobject.cpp      \
	dialogframe.cpp       \
	menupreview.cpp        \
	buttonobject.cpp\
	dialogbutton.cpp \
	qimagehelper.cpp  \
	colortoolbar.cpp   \
	buttonpreview.cpp   \
	xml_dvdauthor.cpp    \
	dialogexecute.cpp     \
	dialogtextfont.cpp     \
	qdvdauthorinit.cpp      \
	sourcefileentry.cpp      \
	objectcollection.cpp      \
	listboxcolortext.cpp       \
	structuretoolbar.cpp        \
	dialogcommandeditor.cpp      \
	sourcetoolbar.cpp \
	qxine/listviewfileitem.cpp\
	qxine/convert.cpp   \
	qxine/xineinfo.cpp   \
	qxine/dialogmovie.cpp \
	qxine/qxinewidget.cpp  \
	qxine/dialogchapters.cpp\
	qslideshow/soundline.cpp \
	qslideshow/imageline.cpp  \
	qslideshow/slidertime.cpp  \
	qslideshow/filterline.cpp   \
	qslideshow/dialogfilter.cpp  \
	qslideshow/dialogcreate.cpp   \
	qslideshow/imagepreview.cpp    \
	qslideshow/xml_slideshow.cpp

HEADERS	+= global.h \
	xml_dvd.h \
	execute.h  \
	dvdinfo.h   \
	dvdmenu.h    \
	dialogman.h   \
	modifiers.h    \
	qdvdauthor.h    \
	menuobject.h     \
	textobject.h      \
	frameobject.h      \
	imageobject.h       \
	movieobject.h        \
	dialogframe.h         \
	menupreview.h          \
	buttonobject.h\
	dialogbutton.h \
	qimagehelper.h  \
	colortoolbar.h   \
	buttonpreview.h   \
	xml_dvdauthor.h    \
	dialogexecute.h     \
	qdvdauthorinit.h     \
	dialogtextfont.h      \
	sourcefileentry.h      \
	objectcollection.h      \
	listboxcolortext.h       \
	structuretoolbar.h        \
	dialogcommandeditor.h      \
	sourcetoolbar.h \
	qxine/convert.h  \
	qxine/xineinfo.h  \
	qxine/dialogmovie.h\
	qxine/qxinewidget.h \
	qxine/qxine_global.h \
	qxine/dialogchapters.h\
	qslideshow/soundline.h \
	qslideshow/imageline.h  \
	qslideshow/slidertime.h  \
	qslideshow/filterline.h   \
	qxine/listviewfileitem.h   \
	qslideshow/dialogfilter.h   \
	qslideshow/dialogcreate.h    \
	qslideshow/imagepreview.h     \
	qslideshow/xml_slideshow.h

DISTFILES	= imglib.inc  \
	imagemagickcmdline.inc \
	cximage.inc      \
	freeimage.inc     \
	imagemagicklib.inc \
	../TODO  \
	../README \
	../INSTALL \
	../COPYING  \
	../CHANGELOG \
	../clean.sh   \
	../configure

FORMS	= formmain.ui           \
	qxine/uidialogmovie.ui   \
	qxine/uidialogchapters.ui \
	qslideshow/dialogslide.ui  \
	qslideshow/dialogimage.ui   \
	qslideshow/uidialogcreate.ui \
	dialogsetup.ui \
	dialogmatrix.ui \
	dialogresize.ui  \
	uidialogframe.ui  \
	uidialogbutton.ui  \
	uisourcewidget.ui   \
	uicommandeditor.ui   \
	uidialogtextfont.ui


IMAGES	= ./images/fileopen ./images/filenew images/filesave images/redo images/undo images/print images/editcut \
	images/editcopy images/editpaste images/searchfind images/to_dvd2.png images/to_dvd.png \
	images/text_ccenter.png images/text_center.png images/text_cfit.png images/text_cjustify.png \
	images/text_cleft.png images/text_cright.png images/text_cstrikeout.png images/text_cunderline.png \
	images/text_cvcenter.png images/text_fit.png images/text_justify.png images/text_left.png \
	images/text_right.png images/text_strikeout.png images/text_underline.png images/text_vcenter.png \
	images/checkered.png images/to_vcd.png images/to_svcd.png
# here we include the images from qxine. needs to be done ...
IMAGES	+=	qxine/images/desktop.png qxine/images/documents.png qxine/images/home.png qxine/images/project.png \
		qxine/images/root.png qxine/images/babytux.png qxine/images/play.png qxine/images/pause.png \
		qxine/images/temp.png

contains( WHICH_QT_LIB, qt) {
	contains( WHICH_QT_LIB, qt-mt) {
		CONFIG += qt-mt
	}
		CONFIG += qt
}

isEmpty(WHICH_PREFIX) {
	WHICH_PREFIX +=/usr
}

prefix.path = $${WHICH_PREFIX}/bin
prefix.files = ../bin/qdvdauthor ../bin/qslideshow ../bin/qxine

DESTDIR =../bin
INSTALLS += prefix

TEMPLATE	 = app
CONFIG		+= thread warn_on debug
LANGUAGE	 = C++


