/****************************************************************************
** QImageHelper
**
** Created: Sun Dec 28 12:09:08 2003
**      by: Varol Okan using kate editor
**
** This class adds some image manipulation routines for QImage objects.
** Please note, that you need FreeImage(Plus) installed in order to have
** some usefull functionality.
**
** However I created this class so it would compile also without this
** library only missing the functionality and thus falling back onto
** the standard functions (E.g. resize becomes the standard RESIZE_QT)
**
****************************************************************************/

#ifndef QIMAGEHELPER_H
#define QIMAGEHELPER_H

#include <qobject.h>
#include <qimage.h>

// global.h holds if FreeImage exists on this machine.
#include "global.h"

// This define is used to indicate that the image(s) are resized using the standard Qt functionality.
#define QT_RESIZE_ALGO "Normal Qt"

#define RESIZE_QT			-1

// The following has to go too ... DVD<Menu Line::353
#define DITHER_FLOYD_STEINBERG	 0
/* Those are supperceeded by the new design ...
// definition of the resize algos from FreeImage.h
#define RESIZE_FILTER_BOX	0
#define RESIZE_BICUBIC		1
#define RESIZE_BILINEAR		2
#define RESIZE_BSPLINE		3
#define RESIZE_CATMULLROM	4
#define RESIZE_LANCZOS3		5
#define RESIZE_QT			6

// definitions of the dither algos from FreeImage.h
#define DITHER_NONE 			-1
#define DITHER_FLOYD_STEINBERG	 0
#define DITHER_BAYER4x4			 1
#define DITHER_BAYER8x8			 2
#define DITHER_CLUSTER6x6		 3
#define DITHER_CLUSTER8x8		 4
#define DITHER_CLUSTER16x16		 5
*/
class QImageHelper : public QImage
{
public:
	QImageHelper  ();
	QImageHelper  (const QString & fileName, const char * format = 0 );
	virtual ~QImageHelper ();

	QStringList &getAvailableResizeAlgorithms();
	uint countColors();	//QImage &image);
	QRgb getMaskColor();

	bool resize (int, int, int);
	bool dither (int, bool);
private:
	void *getImageInLibraryFormat();
	bool setImageFromLibraryFormat(void *);


private:
};

#endif // QIMAGEHELPER_H
